var tagClasses;

function SetTagClasses(dict) {
    tagClasses = eval("(" + dict + ")");
}

function LoadTagClasses(classesElement) {
    var prop, classname;

    if (classesElement.length === 1) {
        
        classname = classesElement.options[classesElement.selectedIndex].text;
        classesElement.options.length = 0;
        
        for (prop in tagClasses) {
             var optionAdd = new Option(prop, prop);
             if (prop == classname) optionAdd.selected = true;
             classesElement.options.add(optionAdd);
        }
    }
}

function LoadTagPaths(tagsElement, tagClassElement) {
    var classname, selectedTag, tags, i, optionAdd;
    classname = tagClassElement.options[tagClassElement.selectedIndex].text;

    if (tagsElement.getAttribute('tagclass') !== classname) {
        tagsElement.setAttribute('tagclass', classname);
        selectedTag = tagsElement.options[tagsElement.selectedIndex].text;
        tags = tagClasses[classname];
        tagsElement.options.length = 0;
        for ( i = 0; i < tags.length; i++) {
            optionAdd = new Option(tags[i], tags[i]);
            if (tags[i] === selectedTag) {
                optionAdd.selected = true;
            }

            tagsElement.options.add(optionAdd);
        }
        tagsElement.onchange();
    }
}

function AddToFloat(id) {
    var valueBox, value, amount, floatBox;

    valueBox = document.getElementById("value" + id);
    value = +valueBox.value;
    amount = +document.getElementById("amount" + id).value;
    value += amount;
    valueBox.value = value;
    floatBox = document.getElementById("main" + id);
    //window.external.PokeFloatValue(valueBox.value, floatBox.getAttribute("mapoffset"));
    ValueOnKeyPress(id, valueBox.value);
}

function RemoveFromFloat(id) {
    var valueBox, value, amount, floatBox;

    valueBox = document.getElementById("value" + id);
    value = +valueBox.value;
    amount = +document.getElementById("amount" + id).value;
    value -= amount;
    valueBox.value = value;
    floatBox = document.getElementById("main" + id);
    //window.external.PokeFloatValue(value, floatBox.getAttribute("mapoffset"));
    ValueOnKeyPress(id, valueBox.value);
}

function ValueOnKeyPress(id, value) {
    var mainvalue, title;

    mainvalue = document.getElementById("main" + id);
    title = document.getElementById("title" + id);
    mainvalue.setAttribute("currentvalue", value);
}

function OnEnumChange(id) {
    var EnumMain, EnumBox;

    EnumMain = document.getElementById("main" + id);
    EnumBox = document.getElementById("select" + id);
    EnumMain.setAttribute("currentvalue", EnumBox.selectedIndex);    
}

function BitmaskCheckAll(id) {
    BitmaskToggleChecks(true, id);
}

function BitmaskUnCheckAll(id) {
    BitmaskToggleChecks(false, id);
}

function BitmaskToggleChecks(checked, id) {
    var bitmaskContainer, checkBoxList, i;
    
    bitmaskContainer = document.getElementById("checkboxcontainer" + id);
    checkBoxList = bitmaskContainer.childNodes;

    for ( i = 0; i < checkBoxList.length; i++) {
        if (checkBoxList[i].type === "checkbox") {
            checkBoxList[i].checked = checked;
        }
    }
}

function BitmaskCheckBoxClick(id) {

}

function IdClassMouseDown(id) {
    LoadTagClasses(document.getElementById("classes" + id));
}

function IdClassChange(id) {
    LoadTagPaths(document.getElementById("paths" + id), document.getElementById("classes" + id));
}

function IdTagPathMouseDown(id) {
    LoadTagPaths(document.getElementById("paths" + id), document.getElementById("classes" + id));
}

function IdTagPathOnChange(id) {
    var maintagbox, classbox, tagsbox, pathid;

    maintagbox = document.getElementById("main" + id);
    classbox = document.getElementById("classes" + id);
    tagsbox = document.getElementById("paths" + id);
    pathid = window.external.GetTagId(classbox.options[classbox.selectedIndex].text, tagsbox.options[tagsbox.selectedIndex].text);
    maintagbox.setAttribute("currentvalue", pathid);
}

//Swapper ID

function SwapperIdClassMouseDown(id, e) {
        if (!e) var e = window.event;
        e.cancelBubble = true;
        if (e.stopPropagation) e.stopPropagation(); 
        
    LoadTagClasses(document.getElementById("classes" + id));
}

function SwapperIdClassChange(id) {
    LoadTagPaths(document.getElementById("paths" + id), document.getElementById("classes" + id));
}

function SwapperIdTagPathMouseDown(id, e) {
        if (!e) var e = window.event;
        e.cancelBubble = true;
        if (e.stopPropagation) e.stopPropagation(); 
        
    LoadTagPaths(document.getElementById("paths" + id), document.getElementById("classes" + id));
}

function SwapperIdTagPathOnChange(id) {
    var maintagbox, classbox, tagsbox, pathid;

    maintagbox = document.getElementById("main" + id);
    classbox = document.getElementById("classes" + id);
    tagsbox = document.getElementById("paths" + id);
    pathid = window.external.GetTagId(classbox.options[classbox.selectedIndex].text, tagsbox.options[tagsbox.selectedIndex].text);
    maintagbox.setAttribute("currentvalue", pathid);
}

function IdSwapperContainerMouseDown(id) {
    container = document.getElementById("container" + id);
     maintagbox = document.getElementById("main" + id);
     
    var Selected = maintagbox.getAttribute("selected");
    
    if(Selected === "f") {
    maintagbox.setAttribute("selected", "t");
    container.style.backgroundColor = "rgb(255, 128, 0)";
}
else
{
    maintagbox.setAttribute("selected", "f");   
 container.style.backgroundColor = "rgb(180,180,180)";
}


}

function SwapperIdContainerMouseOver(id) {
    container = document.getElementById("container" + id);
     maintagbox = document.getElementById("main" + id);
   
     var Selected = maintagbox.getAttribute("selected");
    
    if(Selected === "f") {
    container.style.backgroundColor = "#96C9F2";
}
}

function SwapperIdContainerMouseLeave(id) {
    container = document.getElementById("container" + id);
     maintagbox = document.getElementById("main" + id);
     
     var Selected = maintagbox.getAttribute("selected");
    
    if(Selected === "f") {
    container.style.backgroundColor = "rgb(180,180,180)";
}
}


function StringOnClick(id) {
    var stringbox, stringid, mainbox;

    stringbox = document.getElementById("value" + id);
    stringid = window.external.GetStringId(stringbox.value);

    if (stringid !== "<null>") {
        stringbox.value = stringid;
    }

    mainbox = document.getElementById("main" + id);
    mainbox.setAttribute("currentvalue", stringbox.value);
}
